<?php
class Ittweb_Cvetta_Block_Catalog_Layer extends Mage_Core_Block_Template
{
	protected $attributes_label;
	
	public function getLayer()
	{
		return Mage::registry('current_layer');
	}
	
	public function getAttributes()
	{
		/*return array_filter(
			$this->getLayer()->getFacets(),
			function($item) {
				if ($item == 'categories') return false;
				
				return count($item);
			}
		);*/
		return $this->getLayer()->getFacets();
	}
	
	public function getAttributesLabel($attribute_code)
	{
		if (!$this->attributes_label) {
			$this->attributes_label = $this->initAttributesLabel();
		}
		
		return $this->attributes_label[$attribute_code];
	}
	
	protected function initAttributesLabel()
	{
		$facets = $this->getAttributes();
		$attributes = array();
		foreach ($facets as $facet) {
			$attributes = array_merge($attributes, $facet);
		}

		$_attributes_info = Mage::getSingleton('eav/config')
			->getEntityType(Mage_Catalog_Model_Product::ENTITY)
			->setStoreId(Mage::app()->getStore()->getId())
			->getAttributeCollection()
			->setCodeFilter(array_keys($attributes));

		//$_attributes_info = array_combine( array_column($_attributes_info, 0), array_column($_attributes_info, 1) );
		$_attributes_labels = array();
		foreach($_attributes_info as $_attribute) {
			//$_attributes_label[$_attribute->getAttributeCode()] = $_attribute->getFrontendLabel();
			$_attributes_label[$_attribute->getAttributeCode()] = $_attribute->getStoreLabel();
		}
		$cVettaHelper = $this->helper('cvetta');
		$_attributes_label["categories"] = $cVettaHelper->__('Categories');

		//print_r($_attributes_label);
		
		return $_attributes_label;
	}
	
	public function getUnselectedFilterKeys($current_facet, $_facet_values)
	{
		return array_filter(
			array_keys($_facet_values),
			function ($item) use ($current_facet) {
				return !isset($current_facet[$item]);
			}
		);
	}
	
	public function getFilterUrl($_facet_label, $_filter_value)
	{
	    $params = array(urlencode('facets_label[]') => $_facet_label, urlencode('facets_value[]') => str_replace(' ', '+', $_filter_value), 'p' => 1 /*resetto la paginazione*/);
        $url = Mage::helper('core/url')->getCurrentUrl();
        $url = trim(Mage::helper('core/url')->removeRequestParam($url, 'p', true), '&amp;');
        $url = Mage::helper('core/url')->addRequestParam($url, $params);
		//return Mage::helper('core/url')->getCurrentUrl().'&'.http_build_query($params);
        return $url;
	}
	
	public function getFilterTitle($_facet_type, $_filter_value, $_filter_count)
	{
		if ($_facet_type == 'facet_ranges') {
			$_filter_value = str_replace('[', '€ ', str_replace(']', '', str_replace('+TO+', ' - € ', $_filter_value)));
		}
		return $_filter_value.' <span class="count">('.$_filter_count.')</span>';
	}
	
	public function getClearUrl()
	{
		return Mage::getUrl('*/*/*', array('_query' => array('q' => $this->getRequest()->getParam('q'))));
	}
	
	public function getUnsetFilterUrl($params, $facet_label, $facet_value)
	{
		/*unset($params[$facet_label][$facet_value]);
		$querystring = array('q' => $this->getRequest()->getParam('q'));
		foreach($params as $label => $value) {
			$querystring['facets_label'][] = $label;
			$querystring['facets_value'][] = key($value);
		}*/
		//return Mage::getUrl('*/*/*', array('_query' => $querystring, '_escape' => false));
		$q = $_SERVER["QUERY_STRING"];
		parse_str($q, $params);
        $params["p"] = 1; // resetto la paginazione
		foreach ($params["facets_label"] as $i => $label) {
			if ($label == $facet_label && $params["facets_value"][$i] == $facet_value) {
				unset($params["facets_label"][$i]);
				unset($params["facets_value"][$i]);
			}
		}

		// non posso fare la funzione http_build_query perchè negli array mette l'indice es facets_label[0], facets_label[1]... a me serve facets_label[]
		$url = '';
		foreach($params as $key => $value) {
		    if (is_array($value)) {
		        foreach ($value as $val) {
                    $url .= '&'.$key.urlencode('[]').'='.urlencode($val);
                }
            } else {
                $url .= '&'.$key.'='.urlencode($value);
            }
        }
        if (substr($url, 0, 1) == '&') {
            $url = substr($url, 1);
        }
		return Mage::getUrl('*/*/*').'?'.$url;
	}
	
	public function getUnsetFilterTitle($facet, $value)
	{
		$pos = strpos($value, '+TO+');
		if ($pos !== false) {
			$value = str_replace('[', '€ ', str_replace(']', '', str_replace('+TO+', ' - € ', $value)));
		}
        $pos = strpos($value, ' TO ');
        if ($pos !== false) {
            $value = str_replace('[', '€ ', str_replace(']', '', str_replace(' TO ', ' - € ', $value)));
        }
		return $this->getAttributesLabel($facet).': '.$value;
	}
}