<?php
/**
 * @category Ittweb
 * @package  Ittweb_Cvetta
 * @author   www.ittweb.net
 */

class Ittweb_Cvetta_Model_System_Config_Category {

    public function toOptionArray() {
        $collection = Mage::getResourceModel('catalog/category_collection');

        $collection->addAttributeToSelect('name')
            ->addFieldToFilter('path', array('neq' => '1'))
            ->addAttributeToSort('path', 'asc')
            ->load();

        $options = array();

        foreach ($collection as $category) {
            $depth = count(explode('/', $category->getPath())) - 2;
            $indent = str_repeat('-', max($depth * 2, 0));
            $options[] = array(
               'label' => $indent . $category->getName(),
               'value' => $category->getId()
            );
        }

        return $options;
    }

}
